From 3b338886fc713a11c7af8bd1578fa55e44a5ee30 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 02 2021 19:29:59 +0000
Subject: [PATCH 1965/2232] Merge pull request #640 from capickett/abi


Fix warning mismatching struct and class
---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 97610a4..609814c 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -135,7 +135,7 @@ fn write_data_structures<'a>(out: &mut OutFile<'a>, apis: &'a [Api]) {
         }
     }
     for ty in &slice_in_return_position {
-        write!(out, "template struct ");
+        write!(out, "template class ");
         write_type(out, ty);
         writeln!(out, ";");
     }
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index f043d81..96c5cab 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -827,12 +827,12 @@ std::unique_ptr<I> ns_c_return_unique_ptr_ns() {
 // > serves as an explicit instantiation of the same kind (declaration or
 // > definition) of each of its non-inherited non-template members that has not
 // > been previously explicitly specialized in the translation unit.
-template struct rust::Box<tests::Shared>;
-template struct rust::Slice<const tests::Shared>;
-template struct rust::Slice<tests::Shared>;
-template struct rust::Slice<const tests::R>;
-template struct rust::Slice<tests::R>;
-template struct rust::Vec<uint8_t>;
-template struct rust::Vec<rust::String>;
-template struct rust::Vec<tests::Shared>;
-template struct rust::Fn<size_t(rust::String)>;
+template class rust::Box<tests::Shared>;
+template class rust::Slice<const tests::Shared>;
+template class rust::Slice<tests::Shared>;
+template class rust::Slice<const tests::R>;
+template class rust::Slice<tests::R>;
+template class rust::Vec<uint8_t>;
+template class rust::Vec<rust::String>;
+template class rust::Vec<tests::Shared>;
+template class rust::Fn<size_t(rust::String)>;

